{-# LANGUAGE QuasiQuotes       #-}


module BinaryDownloads where

import           GHCup.Types
import           GHCup.Utils.Prelude

import           Data.String.QQ
import           HPath
import           URI.ByteString.QQ

import qualified Data.Map                      as M


binaryDownloads :: BinaryDownloads
binaryDownloads = M.fromList
  [ ( GHC
    , M.fromList
      [ ( [vver|8.6.5|]
        , VersionInfo [Latest] $ M.fromList
          [ ( A_64
            , M.fromList
              [ ( Linux UnknownLinux
                , M.fromList
                  [ ( Nothing
                    , DownloadInfo
                      [uri|https://downloads.haskell.org/~ghc/8.6.5/ghc-8.6.5-x86_64-fedora27-linux.tar.xz|]
                      (Just ([rel|ghc-8.6.5|] :: Path Rel))
                      [s|5f871a3eaf808acb2420fdeef9318698|]
                    )
                  ]
                )
              , ( Linux Ubuntu
                , M.fromList
                  [ ( Nothing
                    , DownloadInfo
                      [uri|https://downloads.haskell.org/~ghc/8.6.5/ghc-8.6.5-x86_64-fedora27-linux.tar.xz|]
                      (Just ([rel|ghc-8.6.5|] :: Path Rel))
                      [s|5f871a3eaf808acb2420fdeef9318698|]
                    )
                  ]
                )
              , ( Linux Debian
                , M.fromList
                  [ ( Nothing
                    , DownloadInfo
                      [uri|https://downloads.haskell.org/~ghc/8.6.5/ghc-8.6.5-x86_64-debian9-linux.tar.xz|]
                      (Just ([rel|ghc-8.6.5|] :: Path Rel))
                      [s|5f871a3eaf808acb2420fdeef9318698|]
                    )
                  , ( Just $ [vers|8|]
                    , DownloadInfo
                      [uri|https://downloads.haskell.org/~ghc/8.6.5/ghc-8.6.5-x86_64-debian9-linux.tar.xz|]
                      (Just ([rel|ghc-8.6.5|] :: Path Rel))
                      [s|5f871a3eaf808acb2420fdeef9318698|]
                    )
                  ]
                )
              ]
            )
          ]
        ),
        ( [vver|8.4.4|]
        , VersionInfo [] $ M.fromList
          [ ( A_64
            , M.fromList
              [ ( Linux UnknownLinux
                , M.fromList
                  [ ( Nothing
                    , DownloadInfo
                      [uri|https://downloads.haskell.org/~ghc/8.4.4/ghc-8.4.4-x86_64-fedora27-linux.tar.xz|]
                      (Just ([rel|ghc-8.4.4|] :: Path Rel))
                      [s|86785f41d228168461859e40956973fb|]
                    )
                  ]
                )
              , ( Linux Ubuntu
                , M.fromList
                  [ ( Nothing
                    , DownloadInfo
                      [uri|https://downloads.haskell.org/~ghc/8.4.4/ghc-8.4.4-x86_64-fedora27-linux.tar.xz|]
                      (Just ([rel|ghc-8.4.4|] :: Path Rel))
                      [s|f943a245c54c2f2dcb354dceeff886e1|]
                    )
                  ]
                )
              , ( Linux Debian
                , M.fromList
                  [ ( Nothing
                    , DownloadInfo
                      [uri|https://downloads.haskell.org/~ghc/8.6.5/ghc-8.6.5-x86_64-debian9-linux.tar.xz|]
                      (Just ([rel|ghc-8.6.5|] :: Path Rel))
                      [s|f943a245c54c2f2dcb354dceeff886e1|]
                    )
                  , ( Just $ [vers|8|]
                    , DownloadInfo
                      [uri|https://downloads.haskell.org/~ghc/8.6.5/ghc-8.6.5-x86_64-debian8-linux.tar.xz|]
                      (Just ([rel|ghc-8.6.5|] :: Path Rel))
                      [s|f943a245c54c2f2dcb354dceeff886e1|]
                    )
                  ]
                )
              ]
            )
          ]
        )
      ]
    )
  , ( Cabal
    , M.fromList
      [ ( [vver|3.0.0.0|]
        , VersionInfo [Recommended, Latest] $ M.fromList
          [ ( A_64
            , M.fromList
              [ ( Linux UnknownLinux
                , M.fromList
                  [ ( Nothing
                    , DownloadInfo
                      [uri|https://downloads.haskell.org/~cabal/cabal-install-3.0.0.0/cabal-install-3.0.0.0-x86_64-unknown-linux.tar.xz|]
                      Nothing
                      [s|32352d2259909970e6ff04faf61bbfac|]
                    )
                  ]
                )
              ]
            )
          ]
        )
      ]
    )
  ]
